// ConsoleApplication1.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <Windows.h>

#if _M_AMD64

extern "C" __int64 GetSPRegisterValue64();

#else

__declspec(naked) DWORD GetSPRegisterValue32()
{
    __asm
    {
        mov eax, esp
        add eax, 4
        ret
    }
}

#endif

int main()
{
#if _M_AMD64
    __int64 ipRegister = GetSPRegisterValue64();
    printf("0x%016llX\n", ipRegister);
#else
    int ipRegister = GetSPRegisterValue32();
    printf("0x%X\n", ipRegister);
#endif

}
